Attribute VB_Name = "TownGenerator"
Option Explicit

Public Enum PwrCtrMode
    NonPCOnly
    PCOnly
    Both
End Enum

Public Enum RaceDistType
    Custom = 0
    IsolatedHuman = 1
    StandardMixed = 2
    Integrated = 3
    SylvanArea = 4
    RuggedArea = 5
End Enum

Public Enum Race
    Dwarf = 0
    Elf = 1
    Gnome = 2
    Halfling = 3
    HalfElf = 4
    HalfOrc = 5
    Human = 6
End Enum

Public Enum OrgRacialDistribution
    Same_As_Population = 14
    Mostly_Human = 13
    Mostly_HalfElf = 12
    Mostly_Elf = 11
    Mostly_Dwarf = 10
    Mostly_Halfling = 9
    Mostly_Gnome = 8
    Mostly_HalfOrc = 7
    All_Human = 6
    All_HalfElf = 5
    All_Elf = 4
    All_Dwarf = 3
    All_Halfling = 2
    All_Gnome = 1
    All_HalfOrc = 0
End Enum

Public Enum Alignment
    LawfulGood = 0
    NeutralGood = 1
    ChaoticGood = 2
    LawfulNeutral = 3
    TrueNeutral = 4
    ChaoticNeutral = 5
    LawfulEvil = 6
    NeutralEvil = 7
    ChaoticEvil = 8
End Enum

Public Enum SizeClass
    Thorp = 0
    Hamlet = 1
    Village = 2
    SmallTown = 3
    LargeTown = 4
    SmallCity = 5
    LargeCity = 6
    Metropolis = 7
End Enum

Public Enum InternalOrganization
    Bitter_Rivalry
    Competitive_Rivalry
    Cliques
    None
    Good_Old_Boy_Network
    Loose_Fiendships
    Friendly_Rivalry
    Local_Guild
    National_Guild
End Enum

Public Enum GroupStatusTypes
    Official
    Unofficial_Well_Known
    Unofficial_Moderately_Known
    Unofficial_Scarcly_Known
    Secret
End Enum

Public Enum GroupTypes
    Mayor
    TownCouncil
    National_Nobility
    Local_Nobility
    Church
    National_Army
    OccupationGuild
    Wizard
    ExAdventurers
    Thieves_Guild
    Local_Army
    Town_Guard
    Gang
    Town_Militia
    Mercenary
    OccupationNonGuild
    Monster
    UndeadGroup
End Enum

Public Enum SocialStanding
    LowerClass = 0
    LowerMiddle = 1
    Middle = 2
    UpperMiddle = 3
    Upper = 4
    Nobility = 5
    Royality = 6
End Enum

Public Enum MemberType
    Officer = 0
    Leader = 1
    Member = 2
End Enum

Public Enum Deity
    None = 0
    Heironeous = 1
    Moradin = 2
    Yondalla = 3
    Ehlonna = 4
    GarlGlittergold = 5
    Pelor = 6
    CorellonLarethian = 7
    Kord = 8
    WeeJas = 9
    StCuthbert = 10
    Boccob = 11
    Fharlanghn = 12
    ObadHai = 13
    Olidammara = 14
    Hextor = 15
    Nerull = 16
    Vecna = 17
    Erythnul = 18
    Gruumish = 19
End Enum

Public Const c_Elf As Integer = 0
Public Const c_Dwarf As Integer = 1
Public Const c_Human As Integer = 2
Public Const c_Halfling As Integer = 3
Public Const c_HalfElf As Integer = 4
Public Const c_HalfOrc As Integer = 5
Public Const c_Gnome As Integer = 6

Public Enum Frequency
    V = 0   ' Very Common
    C = 1   ' Common
    U = 2   ' Uncommon
    R = 3   ' Rare
End Enum

Public Const NofVict As Integer = 13
Public Const NofCraft As Integer = 33
Public Const NofTrade As Integer = 10
Public Const NofProf As Integer = 18

Public Const NofNatRes As Integer = 6
Public Const NofMoney As Integer = 3
Public Const NofPhysical As Integer = 1

Public NewPantheon As Boolean

Public WealthPen(10) As String
Public SizeString(8) As String
Public RaceString(6) As String
Public PCTypeString(18) As String
Public AlignString(9) As String
Public PCStatusString(5) As String
Public RaceDistTypeString(5) As String
Public GangTypeString(10) As String
Public AreaOfHaunting(13) As String
Public OccuRacialDistString(15) As String
Public OccuOrgString(9) As String
Public NationalPCTypeString(6) As String
Public MilUnitTypeString(20) As String
Public DefensesStrings(6) As String
Public SocialStrings(6) As String

Public NatResStrings(NofNatRes) As String
Public MoneyStrings(NofMoney) As String
Public MoneyScales(NofMoney) As String
Public PhysicalStrings(NofPhysical) As String

Public VictualStrings(NofVict) As String
Public CraftStrings(NofCraft) As String
Public TradeStrings(NofTrade) As String
Public ProfStrings(NofProf) As String

Public newtown As clsTown
Public newPantheons As clsPantheonGroup

Public Sub Main()
    
    Set newtown = New clsTown
    Set newPantheons = New clsPantheonGroup

End Sub

Public Function GetPersonalWealth(Level As Integer, WealthMod As Integer) As Long

    Dim I As Long
    Dim M, N As Double

    Select Case Level
    
    Case 0:
        I = 50
    Case 1:
        I = 900
    Case 2:
        I = 2000
    Case 3:
        I = 2500
    Case 4:
        I = 3300
    Case 5:
        I = 4300
    Case 6:
        I = 5600
    Case 7:
        I = 7200
    Case 8:
        I = 9400
    Case 9:
        I = 12000
    Case 10:
        I = 16000
    Case 11:
        I = 21000
    Case 12:
        I = 27000
    Case 13:
        I = 35000
    Case 14:
        I = 45000
    Case 15:
        I = 59000
    Case 16:
        I = 77000
    Case 17:
        I = 100000
    Case 18:
        I = 130000
    Case 19:
        I = 170000
    Case 20:
        I = 220000
    Case Else:
        I = 50
    End Select

    N = Abs(WealthMod - 49) ^ 0.4
    If (WealthMod - 49) < 0 Then N = N * -1
    M = 1 + (N * 0.07)

    GetPersonalWealth = I * M

End Function

Public Function SignedRoot(X As Integer, Root As Double) As Integer

    Dim Y As Integer
    
    Y = Abs(X) ^ Root
    
    If X < 0 Then Y = Y * -1
    
    SignedRoot = Y

End Function

Public Function BellCurve() As Integer

    Dim I, J As Integer
    
    For I = 1 To 12
        J = J + Int(Rnd(1) * 9)
    Next I
    
    J = J * 100 / 96
    
    BellCurve = J

End Function

Public Sub InitStrings()

    Dim I As Integer
    
    WealthPen(0) = "Only a very few elites"
    WealthPen(1) = "Some elites"
    WealthPen(2) = "Small pop of upper middle class"
    WealthPen(3) = "Upper middle class prosperous"
    WealthPen(4) = "Some prosperous middle class"
    WealthPen(5) = "Most middle class prosperous"
    WealthPen(6) = "A few lower class not in poverty"
    WealthPen(7) = "Little poverty"
    WealthPen(8) = "No poverty"
    WealthPen(9) = "Utopia"
    
    SizeString(0) = "Thorp"
    SizeString(1) = "Hamlet"
    SizeString(2) = "Village"
    SizeString(3) = "Small Town"
    SizeString(4) = "Large Town"
    SizeString(5) = "Small City"
    SizeString(6) = "Large City"
    SizeString(7) = "Metropolis"
    
    DefensesStrings(0) = "None"
    DefensesStrings(1) = "Fenced"
    DefensesStrings(2) = "Pallisaded"
    DefensesStrings(3) = "Partly Walled"
    DefensesStrings(4) = "Walled"
    DefensesStrings(5) = "Walled & Divided"
    DefensesStrings(6) = "Heavily Fortified"
    
    RaceString(0) = "Dwarf"
    RaceString(1) = "Elf"
    RaceString(2) = "Gnome"
    RaceString(3) = "Half Elf"
    RaceString(4) = "Halfling"
    RaceString(5) = "Half Orc"
    RaceString(6) = "Human"
        
    PCTypeString(0) = "None"
    PCTypeString(1) = "Mayor"
    PCTypeString(2) = "TownCouncil"
    PCTypeString(3) = "National_Nobility"
    PCTypeString(4) = "Local_Nobility"
    PCTypeString(5) = "Church"
    PCTypeString(6) = "National_Army"
    PCTypeString(7) = "OccupationGuild"
    PCTypeString(8) = "Wizard(s)"
    PCTypeString(9) = "ExAdventurers"
    PCTypeString(10) = "Thieves_Guild"
    PCTypeString(11) = "Local_Army"
    PCTypeString(12) = "Town_Guard"
    PCTypeString(13) = "Gang"
    PCTypeString(14) = "Town_Militia"
    PCTypeString(15) = "Mercenary"
    PCTypeString(16) = "OccupationNonGuild"
    PCTypeString(17) = "Monster"
    PCTypeString(18) = "Undead"
    
    NationalPCTypeString(0) = "Autocracy"
    NationalPCTypeString(1) = "Limited Autocracy"
    NationalPCTypeString(2) = "Theocracy"
    NationalPCTypeString(3) = "Militocracy"
    NationalPCTypeString(4) = "Magocracy"
    NationalPCTypeString(5) = "Syndicracy"
    
    AlignString(0) = "Lawful Good"
    AlignString(1) = "Neutral Good"
    AlignString(2) = "Chaotic Good"
    AlignString(3) = "Lawful Neutral"
    AlignString(4) = "True Neutral"
    AlignString(5) = "Chaotic Neutral"
    AlignString(6) = "Lawful Evil"
    AlignString(7) = "Neutral Evil"
    AlignString(8) = "Chaotic Evil"
    
    PCStatusString(0) = "Official"
    PCStatusString(1) = "Un-official (univsersally known)"
    PCStatusString(2) = "Un-official (well known)"
    PCStatusString(3) = "Un-official (scarcely known)"
    PCStatusString(4) = "Secret"
        
    RaceDistTypeString(0) = "Custom"
    RaceDistTypeString(1) = "Isolated Human"
    RaceDistTypeString(2) = "Standard Mixed"
    RaceDistTypeString(3) = "Integrated"
    RaceDistTypeString(4) = "Sylvan Area"
    RaceDistTypeString(5) = "Rugged Area"
    
    MilUnitTypeString(0) = "Light Footmen"
    MilUnitTypeString(1) = "Heavy Footmen"
    MilUnitTypeString(2) = "Shortbow Archer"
    MilUnitTypeString(3) = "Light Horsemen"
    MilUnitTypeString(4) = "Crossbowmen"
    MilUnitTypeString(5) = "Mixed Horse & Foot"
    MilUnitTypeString(6) = "Scout Footmen"
    MilUnitTypeString(7) = "Longbow Archer"
    MilUnitTypeString(8) = "Heavy Horsemen"
    MilUnitTypeString(9) = "Pikemen"
    MilUnitTypeString(10) = "Artillerist"
    MilUnitTypeString(11) = "Engineer"
    MilUnitTypeString(12) = "Mounted Bowmen"
    MilUnitTypeString(13) = "Elite Footmen"
    MilUnitTypeString(14) = "Elite Archer"
    MilUnitTypeString(15) = "Elite Horsemen"
    MilUnitTypeString(16) = "PC Classed"
    MilUnitTypeString(17) = "Aerial Mounted Scouts"
    MilUnitTypeString(18) = "Aerial Mounted Knights"
    MilUnitTypeString(19) = "Aerial Mounted Archers"
    MilUnitTypeString(20) = "Aerial Mounted PC Classed"
    
    GangTypeString(0) = "Common Thugs"
    GangTypeString(1) = "Racial Hate Group"
    GangTypeString(2) = "Religious Hate Group"
    GangTypeString(3) = "Slavers"
    GangTypeString(4) = "Unofficial Militia"
    GangTypeString(5) = "Vigilantes"
    GangTypeString(6) = "Organized Crime"
    GangTypeString(7) = "Religious Cult"
    GangTypeString(8) = "Secret Conspiracy"
    GangTypeString(9) = "Assassins Guild"
    
    AreaOfHaunting(0) = "Graveyard"
    AreaOfHaunting(1) = "Building (in use)"
    AreaOfHaunting(2) = "Street (in town)"
    AreaOfHaunting(3) = "Section of Town"
    AreaOfHaunting(4) = "Random Appearances"
    AreaOfHaunting(5) = "Building (abandoned)"
    AreaOfHaunting(6) = "Basement"
    AreaOfHaunting(7) = "Crypt Under Church"
    AreaOfHaunting(8) = "Private Crypt"
    AreaOfHaunting(9) = "Sewers"
    AreaOfHaunting(10) = "Isolated Wood/Park"
    AreaOfHaunting(11) = "Waterway"
    AreaOfHaunting(12) = "Road (out of town)"
    
    
    VictualStrings(0) = "Baker"
    VictualStrings(1) = "Brewer"
    VictualStrings(2) = "Butcher"
    VictualStrings(3) = "Cheesemaker"
    VictualStrings(4) = "Farmer"
    VictualStrings(5) = "Fisherman"
    VictualStrings(6) = "Hunter"
    VictualStrings(7) = "Grocer"
    VictualStrings(8) = "Miller"
    VictualStrings(9) = "Provisioner"
    VictualStrings(10) = "Rancher"
    VictualStrings(11) = "Vintner"
    VictualStrings(12) = "Whaler"
    
    CraftStrings(0) = "Apothecary"
    CraftStrings(1) = "Armorer"
    CraftStrings(2) = "Blacksmith"
    CraftStrings(3) = "Barber"
    CraftStrings(4) = "Bowyer"
    CraftStrings(5) = "Bookbinder"
    CraftStrings(6) = "Brickmaker"
    CraftStrings(7) = "Carpenter"
    CraftStrings(8) = "Cartwright"
    CraftStrings(9) = "Chandler"
    CraftStrings(10) = "Clothier"
    CraftStrings(11) = "Cobler"
    CraftStrings(12) = "Cooper"
    CraftStrings(13) = "Dyer"
    CraftStrings(14) = "Furrier"
    CraftStrings(15) = "Glassblower"
    CraftStrings(16) = "Glazer"
    CraftStrings(17) = "Jeweler"
    CraftStrings(18) = "Leatherworker"
    CraftStrings(19) = "Limner"
    CraftStrings(20) = "Locksmith"
    CraftStrings(21) = "Lumberjack"
    CraftStrings(22) = "Mason"
    CraftStrings(23) = "Potter"
    CraftStrings(24) = "Precious Metal Smith"
    CraftStrings(25) = "Quaryman"
    CraftStrings(26) = "Saddler"
    CraftStrings(27) = "Shipwright"
    CraftStrings(28) = "Tailor"
    CraftStrings(29) = "Tanner"
    CraftStrings(30) = "Tilemaker"
    CraftStrings(31) = "Weaponsmith"
    CraftStrings(32) = "Weaver"
    
    TradeStrings(0) = "Carter"
    TradeStrings(1) = "Fence"
    TradeStrings(2) = "Guide"
    TradeStrings(3) = "Laborer"
    TradeStrings(4) = "Merchants"
    TradeStrings(5) = "Navigator"
    TradeStrings(6) = "Pack Handlers"
    TradeStrings(7) = "Porter"
    TradeStrings(8) = "Sailor"
    TradeStrings(9) = "Stabler"
    
    ProfStrings(0) = "Adventurer"
    ProfStrings(1) = "Alchemist"
    ProfStrings(2) = "Animal Trainer"
    ProfStrings(3) = "Artist"
    ProfStrings(4) = "Assassin"
    ProfStrings(5) = "Astrologer"
    ProfStrings(6) = "Barrister"
    ProfStrings(7) = "Diplomat"
    ProfStrings(8) = "Engineer"
    ProfStrings(9) = "Fencing Instructor"
    ProfStrings(10) = "Healer"
    ProfStrings(11) = "Interpreter"
    ProfStrings(12) = "Minstrel"
    ProfStrings(13) = "Sage"
    ProfStrings(14) = "Scribe"
    ProfStrings(15) = "Soldier"
    ProfStrings(16) = "Spy"
    ProfStrings(17) = "Teacher"
    
    OccuRacialDistString(14) = "Same As Population"
    OccuRacialDistString(13) = "Mostly Human"
    OccuRacialDistString(12) = "Mostly Half-Elven"
    OccuRacialDistString(11) = "Mostly Elven"
    OccuRacialDistString(10) = "Mostly Dwarven"
    OccuRacialDistString(9) = "Mostly Halfling"
    OccuRacialDistString(8) = "Mostly Gnome"
    OccuRacialDistString(7) = "Mostly Half-Orc"
    OccuRacialDistString(6) = "All Human"
    OccuRacialDistString(5) = "All Half-Elven"
    OccuRacialDistString(4) = "All Elven"
    OccuRacialDistString(3) = "All Dwarven"
    OccuRacialDistString(2) = "All Halfling"
    OccuRacialDistString(1) = "All Gnome"
    OccuRacialDistString(0) = "All Half-Orc"
    
    OccuOrgString(0) = "Bitter Rivalry"
    OccuOrgString(1) = "Competitive Rivalry"
    OccuOrgString(2) = "Cliques"
    OccuOrgString(3) = "None"
    OccuOrgString(4) = "Good Old Boy Network"
    OccuOrgString(5) = "Loose Fiendships"
    OccuOrgString(6) = "Friendly Rivalry"
    OccuOrgString(7) = "Local Guild"
    OccuOrgString(8) = "National Guild"

    NatResStrings(0) = "Livestock"
    NatResStrings(1) = "Produce"
    NatResStrings(2) = "Timber"
    NatResStrings(3) = "Cloth"
    NatResStrings(4) = "Stone"
    NatResStrings(5) = "Metal"

    MoneyStrings(0) = "Merchants"
    MoneyStrings(1) = "Markets"
    MoneyStrings(2) = "Trade Basis"
    
    MoneyScales(0) = "  Local              Mix             Foreign"
    MoneyScales(1) = "  Local              Mix             Foreign"
    MoneyScales(2) = "  Barter            Norm             Cash"

    PhysicalStrings(0) = "Town Layout"
    
    SocialStrings(0) = "Lower Class"
    SocialStrings(1) = "LowerMiddle"
    SocialStrings(2) = "Middle"
    SocialStrings(3) = "UpperMiddle"
    SocialStrings(4) = "Upper"
    SocialStrings(5) = "Nobility"
    SocialStrings(6) = "Royality"
        
End Sub

Public Function ConvertSkillToMaxLevel(skill As Integer) As Integer

    ConvertSkillToMaxLevel = (newtown.SizeClass ^ 1.3) + (10 - (100 - skill) ^ 0.5)

End Function
