VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsPowerCenters"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Attribute VB_Ext_KEY = "SavedWithClassBuilder6" ,"Yes"
Attribute VB_Ext_KEY = "Top_Level" ,"Yes"
Option Explicit

Private m_ListIndex As Integer        'from 1 to m_ListCount, m_Current points at this one
Private m_ListCount As Integer        'number of PCs in the town
Private m_Current As clsGroup         'copy of current group from town's group list
Private m_CountVerified As Boolean    'set to false everytime group.PC is written to
Private m_indices() As Integer        'the actual indices in the town's group list

Public Property Let CountVerified(ByVal vData As Boolean)
    
    m_CountVerified = vData

End Property

Public Property Get CountVerified() As Boolean
    
    CountVerified = m_CountVerified

End Property

Public Property Get Current() As clsGroup

    If m_CountVerified = False Then
        Debug.Print "Warning: m_Current read when m_CountVerified = False"
    End If
    
    Set Current = m_Current

End Property

Public Property Get ActualGroupNumber() As Integer

    ActualGroupNumber = m_indices(m_ListIndex)

End Property

Public Property Let ListCount(ByVal vData As Integer)
    
    m_ListCount = vData

End Property

Public Property Get ListCount() As Integer
    
    ListCount = m_ListCount

End Property

Public Property Let ListIndex(ByVal vData As Integer)
    
    Call VerifyCount                        'make sure the count is accurate
    
    If vData < 1 Then
        If m_ListCount > 0 Then             'if the list isn't empty
            Debug.Print "Tried to set PwrCtr ListIndex to " + CStr(vData) + " when ListCount = " + CStr(m_ListCount)
        End If
        m_ListIndex = 0
        Set m_Current = Nothing
    Else
        If vData > m_ListCount Then         'tried to set it too big
            m_ListIndex = m_ListCount
            Debug.Print "Tried to set PwrCtr ListIndex to " + CStr(vData) + " when ListCount = " + CStr(m_ListCount)
        Else                                'everything ok
            m_ListIndex = vData
        End If
        Set m_Current = newtown.Groups.Item(m_indices(m_ListIndex))
    End If
    
End Property

Public Property Get ListIndex() As Integer
    
    ListIndex = m_ListIndex

End Property

Public Sub AddRandom(Optional Index As Integer = -1)

    Dim I As Integer

    Set m_Current = Nothing
    
    Set m_Current = New clsGroup
    m_Current.PowerCenter = True
    Set m_Current.Align = newtown.AlignDist.GetRndAlign
    m_Current.MSMod = BellCurve()
    m_Current.SizeMod = BellCurve()
    m_Current.Wealth = (Int(Rnd(1) * (100 - newtown.GPLimitMod)) + newtown.GPLimitMod)
    m_Current.MaxLevel = (m_Current.SizeMod / 5.5) + Int(Rnd(1) * 4)
    m_Current.gpType = RandomizePowerCenterType
    m_Current.GpSubType = m_Current.GpSubType.GetRndSubType(m_Current.gpType)
    Call m_Current.OrgRace.SetRndOrgRaceDist(m_Current.gpType, m_Current.GroupName, m_Current.GpSubType.SubTypeString)
    m_Current.God = newtown.Pantheon.GetRandomGod(m_Current.Align, m_Current.OrgRace)
    m_Current.StatusType = RandomizeStatus
    m_Current.InternOrg = Competitive_Rivalry   'need to spice this up
    I = (m_Current.MSMod + m_Current.SizeMod + m_Current.Wealth) / 3
    m_Current.Influence = 100 - Abs(I - 50) - Int(Rnd(1) * 10)
    
    Call m_Current.RandomizeMembers
    
    If Index = -1 Then
        Call newtown.AddGroup(m_Current)
    Else
        Call newtown.AddGroup(m_Current, Index)
    End If
    
    m_CountVerified = False

    Call RebalanceRelStr

End Sub

Public Sub Clear()

    Dim I As Integer
    
    For I = newtown.Groups.count To 1 Step -1
        If newtown.Groups.Item(I).PowerCenter = True Then
            newtown.Groups.Remove (I)
        End If
    Next I
    
    m_ListCount = 0
    m_ListIndex = 0
    Set m_Current = Nothing
    m_CountVerified = True

End Sub

Private Sub Class_Initialize()

    m_ListCount = 0
    m_ListIndex = 0
    Set m_Current = Nothing
    m_CountVerified = False

End Sub

Private Function RandomizeStatus() As GroupStatusTypes

    Dim I As Integer
    Dim Status As GroupStatusTypes
    
    On Error GoTo NoGroupInitializedError
    I = m_Current.gpType
    On Error GoTo 0
    
    I = Int(Rnd(1) * 100) + 1
    
    Select Case m_Current.gpType
    
    Case Mayor
        If I < 60 Then
            Status = Official
        ElseIf I < 75 Then
            Status = Unofficial_Well_Known
        ElseIf I < 85 Then
            Status = Unofficial_Moderately_Known
        ElseIf I < 95 Then
            Status = Unofficial_Scarcly_Known
        Else
            Status = Secret
        End If
    Case TownCouncil
        If I < 40 Then
            Status = Official
        ElseIf I < 65 Then
            Status = Unofficial_Well_Known
        ElseIf I < 80 Then
            Status = Unofficial_Moderately_Known
        ElseIf I < 90 Then
            Status = Unofficial_Scarcly_Known
        Else
            Status = Secret
        End If
    Case National_Nobility
        If I < 80 Then
            Status = Official
        ElseIf I < 85 Then
            Status = Unofficial_Well_Known
        ElseIf I < 90 Then
            Status = Unofficial_Moderately_Known
        ElseIf I < 95 Then
            Status = Unofficial_Scarcly_Known
        Else
            Status = Secret
        End If
    Case Local_Nobility
        If I < 50 Then
            Status = Official
        ElseIf I < 85 Then
            Status = Unofficial_Well_Known
        ElseIf I < 95 Then
            Status = Unofficial_Moderately_Known
        ElseIf I < 99 Then
            Status = Unofficial_Scarcly_Known
        Else
            Status = Secret
        End If
    Case Church
        If I < 50 Then
            Status = Official
        ElseIf I < 80 Then
            Status = Unofficial_Well_Known
        ElseIf I < 95 Then
            Status = Unofficial_Moderately_Known
        ElseIf I < 97 Then
            Status = Unofficial_Scarcly_Known
        Else
            Status = Secret
        End If
    Case National_Army
        Status = Official
    Case OccupationGuild
        If I < 30 Then
            Status = Official
        ElseIf I < 80 Then
            Status = Unofficial_Well_Known
        ElseIf I < 90 Then
            Status = Unofficial_Moderately_Known
        ElseIf I < 98 Then
            Status = Unofficial_Scarcly_Known
        Else
            Status = Secret
        End If
    Case Wizard
        If I < 20 Then
            Status = Official
        ElseIf I < 40 Then
            Status = Unofficial_Well_Known
        ElseIf I < 60 Then
            Status = Unofficial_Moderately_Known
        ElseIf I < 80 Then
            Status = Unofficial_Scarcly_Known
        Else
            Status = Secret
        End If
    Case ExAdventurers
        If I < 20 Then
            Status = Official
        ElseIf I < 40 Then
            Status = Unofficial_Well_Known
        ElseIf I < 60 Then
            Status = Unofficial_Moderately_Known
        ElseIf I < 80 Then
            Status = Unofficial_Scarcly_Known
        Else
            Status = Secret
        End If
    Case Thieves_Guild
        If I < 4 Then
            Status = Official
        ElseIf I < 15 Then
            Status = Unofficial_Well_Known
        ElseIf I < 35 Then
            Status = Unofficial_Moderately_Known
        ElseIf I < 70 Then
            Status = Unofficial_Scarcly_Known
        Else
            Status = Secret
        End If
    Case Local_Army
        Status = Official
    Case Town_Guard
        Status = Official
    Case Gang
        If I < 10 Then
            Status = Official
        ElseIf I < 25 Then
            Status = Unofficial_Well_Known
        ElseIf I < 50 Then
            Status = Unofficial_Moderately_Known
        ElseIf I < 75 Then
            Status = Unofficial_Scarcly_Known
        Else
            Status = Secret
        End If
    Case Town_Militia
        If I < 70 Then
            Status = Official
        ElseIf I < 95 Then
            Status = Unofficial_Well_Known
        Else
            Status = Unofficial_Moderately_Known
        End If
    Case Mercenary
        If I < 15 Then
            Status = Official
        ElseIf I < 75 Then
            Status = Unofficial_Well_Known
        ElseIf I < 95 Then
            Status = Unofficial_Moderately_Known
        Else
            Status = Unofficial_Scarcly_Known
        End If
    Case OccupationNonGuild
        If I < 80 Then
            Status = Official
        ElseIf I < 95 Then
            Status = Unofficial_Well_Known
        Else
            Status = Unofficial_Moderately_Known
        End If
    Case Monster
        If I < 6 Then
            Status = Official
        ElseIf I < 25 Then
            Status = Unofficial_Well_Known
        ElseIf I < 40 Then
            Status = Unofficial_Moderately_Known
        ElseIf I < 70 Then
            Status = Unofficial_Scarcly_Known
        Else
            Status = Secret
        End If
    Case UndeadGroup
        If newtown.AlignDist.Good < 25 Then      'Mostly Evil in town?
            If I < 10 Then
                Status = Official
            ElseIf I < 25 Then
                Status = Unofficial_Well_Known
            ElseIf I < 45 Then
                Status = Unofficial_Moderately_Known
            ElseIf I < 70 Then
                Status = Unofficial_Scarcly_Known
            Else
                Status = Secret
            End If
        Else
            If I < 3 Then
                Status = Official
            ElseIf I < 12 Then
                Status = Unofficial_Well_Known
            ElseIf I < 25 Then
                Status = Unofficial_Moderately_Known
            ElseIf I < 50 Then
                Status = Unofficial_Scarcly_Known
            Else
                Status = Secret
            End If
        End If
    Case Default
        Status = Int(Rnd(1) * 5)
    End Select
    
    ' need cases for the rest of the GroupTypes
    
    RandomizeStatus = Status
    Exit Function
    
NoGroupInitializedError:
    Debug.Print "RandomizeStatus in clsPowerCenters was called with no active group."
    RandomizeStatus = Official

End Function

Private Function RandomizePowerCenterType() As GroupTypes

    Dim I, J As Integer
    Dim PwrCtr As GroupTypes
    Dim Here As clsSurroundings
    
    I = Int(Rnd(1) * (20 + newtown.SizeClass)) + 1
    
    If I < 14 Then
        PwrCtr = Int(Rnd(1) * 7) + 1
    ElseIf I < 20 Then
        PwrCtr = Int(Rnd(1) * 11) + 1
    Else
        PwrCtr = Int(Rnd(1) * 18) + 1
    End If
    
    Set Here = newtown.Areas
    
    If newtown.Areas.Independent = True Then
        If (PwrCtr = National_Army) Or (PwrCtr = National_Nobility) Then
            PwrCtr = Local_Nobility
        End If
    Else
        I = Int(Rnd(1) * 100) + 1 - (Here.LocalInflNatl / 2)
        If I < Here.NatlInflLocal And Here.NatlInflLocal > 50 Then
            If (I Mod 2) = 0 Then
                PwrCtr = National_Nobility
            Else
                PwrCtr = National_Army
            End If
        End If
        I = Int(Rnd(1) * 100) + 1 - (Here.NatlInflLocal / 2)
        If I < Here.LocalInflNatl And Here.LocalInflNatl > 50 Then
            J = I Mod 8
            If J = 0 Then
                PwrCtr = Mayor
            ElseIf J = 1 Then
                PwrCtr = TownCouncil
            ElseIf J = 2 Then
                PwrCtr = Local_Nobility
            ElseIf J = 3 Then
                PwrCtr = Church
            ElseIf J = 4 Then
                PwrCtr = OccupationGuild
            ElseIf J = 5 Then
                PwrCtr = Wizard
            ElseIf J = 6 Then
                PwrCtr = ExAdventurers
            ElseIf J = 7 Then
                PwrCtr = Thieves_Guild
            End If
        End If
    End If
        
    Set Here = Nothing
    
    RandomizePowerCenterType = PwrCtr

End Function

Private Sub RebalanceRelStr()

    Dim I, J, tempIndex, tempInfluence As Integer
    Dim Index() As Integer
    Dim Influence() As Integer
        
    Call VerifyCount
    
    If m_ListCount = 0 Then Exit Sub
    
    J = 0
    For I = 1 To newtown.Groups.count
        If newtown.Groups.Item(I).PowerCenter = True Then
            J = J + 1
            ReDim Preserve Index(J)
            ReDim Preserve Influence(J)
            m_ListCount = J
            Index(J) = I
            Influence(J) = newtown.Groups.Item(I).Influence
        End If
    Next I
    
    For I = 1 To m_ListCount - 1            ' bubble sort highest to lowest
        For J = 1 To m_ListCount - 1
            If Influence(I) < Influence(I + 1) Then
                tempInfluence = Influence(I + 1)
                tempIndex = Index(I + 1)
                Influence(I + 1) = Influence(I)
                Index(I + 1) = Index(I)
                Influence(I) = tempInfluence
                Index(I) = tempIndex
            End If
        Next J
    Next I

    For I = 1 To m_ListCount
        newtown.Groups.Item(Index(I)).RelStr = I
    Next I

End Sub

Public Sub ForceOneOfficial()

    Dim temp As clsGroup
    Dim low As GroupStatusTypes
    Dim I, lowindex As Integer
    
    Call VerifyCount
    
    If m_ListCount = 0 Then Exit Sub
    
    If m_ListCount = 1 Then
        Set temp = newtown.Groups.Item(1)
        Call newtown.Groups.Remove(1)
        temp.StatusType = Official
        Call newtown.Groups.Add(temp)
        Exit Sub
    End If
    
    low = Secret
    For I = 1 To newtown.Groups.count
        If newtown.Groups.Item(I).PowerCenter = True Then
            If newtown.Groups.Item(I).StatusType = Official Then
                Exit Sub
            Else
                If newtown.Groups.Item(I).StatusType < low Then
                    low = newtown.Groups.Item(I).StatusType
                    lowindex = I
                End If
            End If
        End If
    Next
    
    Set temp = newtown.Groups.Item(lowindex)
    Call newtown.Groups.Remove(lowindex)
    m_ListCount = m_ListCount - 1
    temp.StatusType = Official
    If m_ListCount = 1 And lowindex = 2 Then
        Call newtown.Groups.Add(temp, , , 1)
    Else
        Call newtown.Groups.Add(temp, , lowindex)
    End If

End Sub

Public Sub RandomizePowerCenters(Optional Index As Integer = -1)

    Dim cnt, I As Integer
    
    cnt = Val(frmSizeWealth.lblPowerCenters.Caption)
    
    If Index = -1 Then         ' randomizing all of them
        Call Clear
        For I = 1 To cnt
            Call AddRandom
        Next I
    Else                       ' if just randomizing 1 of them
        Call newtown.Groups.Remove(m_ListIndex)
        Call AddRandom(m_ListIndex)
    End If
    
    Call ForceOneOfficial
    Call RebalanceRelStr
    
    If Index = -1 Then
        frmSizeWealth.vsbPCDetails.value = 0
    End If
    
End Sub

Public Function CheckCount(count As Integer) As Boolean

    If count = newtown.Groups.count Then
        CheckCount = True
    Else
        CheckCount = False
    End If

End Function

Public Sub VerifyCount()

    Dim I, J As Integer
    
    If m_CountVerified = False Then
        J = 0
        For I = 1 To newtown.Groups.count
            If newtown.Groups.Item(I).PowerCenter = True Then
                J = J + 1
                ReDim Preserve m_indices(J)
                m_ListCount = J
                m_indices(J) = I
            End If
        Next I
        m_CountVerified = True
    End If

End Sub
