VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsRaceDistribution"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Attribute VB_Ext_KEY = "SavedWithClassBuilder6" ,"Yes"
Attribute VB_Ext_KEY = "Top_Level" ,"Yes"
Option Explicit

Private m_Elf As Integer
Private m_Dwarf As Integer
Private m_Human As Integer
Private m_Halfling As Integer
Private m_HalfElf As Integer
Private m_HalfOrc As Integer
Private m_Gnome As Integer

Private m_OldArray(6) As Integer
Private m_NewArray(6) As Integer
Private m_Locked(6) As Boolean
Private m_PointsUnlocked As Integer
Private m_ChannelsUnlocked As Integer

Private m_DistType As RaceDistType

Private Function ReBalance(ByVal Index As Integer, ByVal value As Integer) As Boolean

    Dim I, change As Integer
    
    m_NewArray(Index) = value
    
    change = m_NewArray(Index) - m_OldArray(Index)
    
    If change > 0 Then
        If m_PointsUnlocked < change Then
            If m_PointsUnlocked > 0 Then
                change = m_PointsUnlocked
                m_NewArray(Index) = m_OldArray(Index) + change
            Else
                Beep
                m_NewArray(Index) = m_OldArray(Index)
                Exit Function
            End If
        End If
        I = 0
        Do While (change > 0)
            If m_Locked(I) = False And I <> Index And m_NewArray(I) > 0 Then
                m_NewArray(I) = m_NewArray(I) - 1
                change = change - 1
            End If
            I = I + 1
            If I = 7 Then
                I = 0
                DoEvents
            End If
        Loop
    ElseIf change < 0 Then
        If m_ChannelsUnlocked = 0 Then
            Beep
            m_NewArray(Index) = m_OldArray(Index)
            Exit Function
        End If
        I = 0
        Do While (change < 0)
            If m_Locked(I) = False And I <> Index And m_NewArray(I) < 100 Then
                m_NewArray(I) = m_NewArray(I) + 1
                change = change + 1
            End If
            I = I + 1
            If I = 7 Then
                I = 0
                DoEvents
            End If
        Loop
    Else
        'no change?
    End If
    
    Call UpdateFromNewArray
    
End Function

Private Sub UpdateFromNewArray()

    Dim I As Integer
    
    For I = 0 To 6
        m_OldArray(I) = m_NewArray(I)
    Next I
    
    m_Elf = m_NewArray(c_Elf)
    m_Dwarf = m_NewArray(c_Dwarf)
    m_Human = m_NewArray(c_Human)
    m_Halfling = m_NewArray(c_Halfling)
    m_HalfElf = m_NewArray(c_HalfElf)
    m_HalfOrc = m_NewArray(c_HalfOrc)
    m_Gnome = m_NewArray(c_Gnome)
    
    Call CalculateLocks

End Sub

Public Sub SetLock(Index As Integer, value As Boolean)

    If Index <= 6 And Index >= 0 Then
        If value = m_Locked(Index) Then
            Exit Sub            'nothing changed, just leave
        Else
            m_Locked(Index) = value
            Call CalculateLocks
        End If
    End If

End Sub

Private Sub CalculateLocks()

    Dim I As Integer
    
    m_PointsUnlocked = 0
    m_ChannelsUnlocked = 0
    
    For I = 0 To 6
        If m_Locked(I) = False Then
            m_PointsUnlocked = m_PointsUnlocked + m_NewArray(I)
            m_ChannelsUnlocked = m_ChannelsUnlocked + 1
        End If
    Next I

End Sub

Public Property Let DistType(ByVal vData As RaceDistType)
    
    m_DistType = vData

End Property

Public Property Get DistType() As RaceDistType
    
    DistType = m_DistType

End Property

Public Function GetRaceAsArray(Index As Integer) As Integer

    Select Case Index
    Case c_Elf
        GetRaceAsArray = m_Elf
    Case c_Dwarf
        GetRaceAsArray = m_Dwarf
    Case c_Human
        GetRaceAsArray = m_Human
    Case c_Halfling
        GetRaceAsArray = m_Halfling
    Case c_HalfElf
        GetRaceAsArray = m_HalfElf
    Case c_HalfOrc
        GetRaceAsArray = m_HalfOrc
    Case c_Gnome
        GetRaceAsArray = m_Gnome
    Case Else
        Debug.Print "Error:GetRaceAsArray    Tried to get an invalid race index.  Index:" & CStr(Index)
        GetRaceAsArray = 0
    End Select

End Function

Public Sub ResetRaceDist(Index As Integer)

    Dim R As RaceDistType
    
    m_DistType = Index
    
    Select Case Index
    Case Custom
        m_Human = 15
        m_Elf = 15
        m_Dwarf = 14
        m_Gnome = 14
        m_Halfling = 14
        m_HalfElf = 14
        m_HalfOrc = 14
    Case IsolatedHuman
        m_Human = 95
        m_Elf = 1
        m_Dwarf = 0
        m_Gnome = 0
        m_Halfling = 2
        m_HalfElf = 2
        m_HalfOrc = 0
    Case StandardMixed
        m_Human = 79
        m_Elf = 5
        m_Dwarf = 3
        m_Gnome = 2
        m_Halfling = 9
        m_HalfElf = 1
        m_HalfOrc = 1
    Case Integrated
        m_Human = 37
        m_Elf = 18
        m_Dwarf = 10
        m_Gnome = 7
        m_Halfling = 20
        m_HalfElf = 5
        m_HalfOrc = 3
    Case SylvanArea
        m_Human = 10
        m_Elf = 60
        m_Dwarf = 1
        m_Gnome = 10
        m_Halfling = 5
        m_HalfElf = 14
        m_HalfOrc = 0
    Case RuggedArea
        m_Human = 35
        m_Elf = 2
        m_Dwarf = 35
        m_Gnome = 15
        m_Halfling = 2
        m_HalfElf = 1
        m_HalfOrc = 10
    End Select
    
    Call CopyToArrays
    
End Sub

Public Sub CopyToArrays()

    m_NewArray(c_Elf) = m_Elf
    m_NewArray(c_Dwarf) = m_Dwarf
    m_NewArray(c_Human) = m_Human
    m_NewArray(c_Halfling) = m_Halfling
    m_NewArray(c_HalfElf) = m_HalfElf
    m_NewArray(c_HalfOrc) = m_HalfOrc
    m_NewArray(c_Gnome) = m_Gnome

    m_OldArray(c_Elf) = m_Elf
    m_OldArray(c_Dwarf) = m_Dwarf
    m_OldArray(c_Human) = m_Human
    m_OldArray(c_Halfling) = m_Halfling
    m_OldArray(c_HalfElf) = m_HalfElf
    m_OldArray(c_HalfOrc) = m_HalfOrc
    m_OldArray(c_Gnome) = m_Gnome

End Sub

Public Sub RandomizeDistribution()
    
    Dim I, J, K, L, temp, newTot As Integer
    Dim ratio As Double
    Dim Race(6) As Single
    
    Race(c_Elf) = m_Elf
    Race(c_Dwarf) = m_Dwarf
    Race(c_Human) = m_Human
    Race(c_Halfling) = m_Halfling
    Race(c_HalfElf) = m_HalfElf
    Race(c_HalfOrc) = m_HalfOrc
    Race(c_Gnome) = m_Gnome
    
    For I = 0 To 6
        temp = Race(I)
        L = Int(Rnd(1) * (20 + temp)) - ((temp / 2) + 10)
        temp = temp + L
        If temp < 0 Then temp = 0
        If temp > 100 Then temp = 100
        Race(I) = temp
        newTot = newTot + temp
    Next I
    
    ratio = 100 / newTot
    newTot = 0
    
    For I = 0 To 6
        Race(I) = Race(I) * ratio
        newTot = newTot + Race(I)
    Next I
    
    Do While (newTot <> 100)
        J = Int(Rnd(1) * 7)
        If (newTot > 100) And (Race(J) > 0) Then
            Race(J) = Race(J) - 1
            newTot = newTot - 1
        End If
        If (newTot < 100) And (Race(J) < 100) Then
            Race(J) = Race(J) + 1
            newTot = newTot + 1
        End If
        K = DoEvents()
    Loop

    m_Elf = Race(c_Elf)
    m_Dwarf = Race(c_Dwarf)
    m_Human = Race(c_Human)
    m_Halfling = Race(c_Halfling)
    m_HalfElf = Race(c_HalfElf)
    m_HalfOrc = Race(c_HalfOrc)
    m_Gnome = Race(c_Gnome)

    Call CopyToArrays

End Sub

Public Function GetRndRace() As clsRace

    Dim I, J As Single
    Dim temp As clsRace
    
    Set temp = New clsRace
    I = Int(Rnd(1) * 100)
    
    J = m_Elf
    If I < J Then
        temp.RaceName = "Elf"
    Else
        J = J + m_Dwarf
        If I < J Then
            temp.RaceName = "Dwarf"
        Else
            J = J + m_Human
            If I < J Then
                temp.RaceName = "Human"
            Else
                J = J + m_Halfling
                If I < J Then
                    temp.RaceName = "Halfling"
                Else
                    J = J + m_HalfElf
                    If I < J Then
                        temp.RaceName = "Half Elf"
                    Else
                        J = J + m_HalfOrc
                        If I < J Then
                            temp.RaceName = "Half Orc"
                        Else
                            J = J + m_Gnome
                            If I < J Then
                                temp.RaceName = "Gnome"
                            End If
                        End If
                    End If
                End If
            End If
        End If
    End If
        
    Set GetRndRace = temp

End Function

Public Function GetPluralityRace() As clsRace

    Dim temp As clsRace
    Dim I, max As Integer
    
    Set temp = New clsRace
    
    temp.RaceEnum = Elf
    max = m_Elf
    
    If m_Dwarf > max Then
        temp.RaceEnum = Dwarf
        max = m_Dwarf
    End If
    
    If m_Human > max Then
        temp.RaceEnum = Human
        max = m_Human
    End If
    
    If m_Halfling > max Then
        temp.RaceEnum = Halfling
        max = m_Halfling
    End If
    
    If m_HalfElf > max Then
        temp.RaceEnum = HalfElf
        max = m_HalfElf
    End If
    
    If m_HalfOrc > max Then
        temp.RaceEnum = HalfOrc
        max = m_HalfOrc
    End If
    
    If m_Gnome > max Then
        temp.RaceEnum = Gnome
        max = m_Gnome
    End If
    
    Set GetPluralityRace = temp

End Function

Public Property Let GnomeChance(ByVal vData As Single)
    
    Call ReBalance(Gnome, vData)
    
End Property

Public Property Get GnomeChance() As Single
    
    GnomeChance = m_Gnome

End Property

Public Property Let HalfOrcChance(ByVal vData As Single)
    
    Call ReBalance(HalfOrc, vData)

End Property

Public Property Get HalfOrcChance() As Single
    
    HalfOrcChance = m_HalfOrc

End Property

Public Property Let HalfElfChance(ByVal vData As Single)
    
    Call ReBalance(HalfElf, vData)

End Property

Public Property Get HalfElfChance() As Single
    
    HalfElfChance = m_HalfElf

End Property

Public Property Let HalflingChance(ByVal vData As Single)
    
    Call ReBalance(Halfling, vData)

End Property

Public Property Get HalflingChance() As Single
    
    HalflingChance = m_Halfling

End Property

Public Property Let HumanChance(ByVal vData As Single)
    
    Call ReBalance(Human, vData)

End Property

Public Property Get HumanChance() As Single
    
    HumanChance = m_Human

End Property

Public Property Let DwarfChance(ByVal vData As Single)
    
    Call ReBalance(Dwarf, vData)

End Property

Public Property Get DwarfChance() As Single
    
    DwarfChance = m_Dwarf

End Property

Public Property Let ElfChance(ByVal vData As Single)
    
    Call ReBalance(Elf, vData)

End Property

Public Property Get ElfChance() As Single
    
    ElfChance = m_Elf

End Property
