VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsTown"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Attribute VB_Ext_KEY = "SavedWithClassBuilder6" ,"Yes"
Attribute VB_Ext_KEY = "Top_Level" ,"Yes"
Option Explicit

Private m_TownName As String
Private m_Area As clsSurroundings
Private m_AlignDist As clsAlignDist
Private m_RaceDist As clsRaceDistribution
Private m_SizeMod As Integer
Private m_Population As Long
Private m_PwrCtrs As clsPowerCenters
Private m_SizeClass As SizeClass
Private m_GPLimitMod As Integer
Private m_GPLimit As Long
Private m_Pantheon As clsPantheon
Private m_Groups As Collection
Private m_CurGroup As clsGroup
Private m_CurGpIndex As Long
Private m_CurGroupSet As Boolean
Private m_CurGpType As GroupTypes
Private m_CurGpNumber As Integer
Private m_Stats As clsStatistics

Private m_SizeBase(9) As Long
Private m_LimitBase(9) As Long

Public Function FindFirstGroupByType(vData As GroupTypes) As Boolean

    Dim Group As clsGroup
    Dim I As Integer
    Dim Found As Boolean
    
    Set m_CurGroup = Nothing
    
    Found = False
    For I = 1 To m_Groups.count
        Set Group = m_Groups.Item(I)
        If Group.gpType = vData Then
            Set m_CurGroup = m_Groups.Item(I)
            m_CurGroupSet = True
            m_CurGpType = m_CurGroup.gpType
            m_CurGpIndex = I
            m_CurGpNumber = 1
            Found = True
            Exit For
        End If
        Set Group = Nothing
    Next I
    
    If Found = False Then
        Set m_CurGroup = Nothing
        m_CurGroupSet = False
        m_CurGpType = Church
        m_CurGpIndex = -1
        m_CurGpNumber = 0
    End If
    
    FindFirstGroupByType = Not Found

End Function

Public Function FindNextGroupByType() As Boolean

    Dim I, Start As Integer
    Dim Found As Boolean
    Dim SearchType As GroupTypes
    
    Start = m_CurGpIndex + 1
    SearchType = m_CurGroup.gpType
    Found = False
    
    Set m_CurGroup = Nothing
    
    If Start <= m_Groups.count Then
        For I = Start To m_Groups.count
            If m_Groups.Item(I).gpType = SearchType Then
                Set m_CurGroup = m_Groups.Item(I)
                m_CurGroupSet = True
                m_CurGpType = m_CurGroup.gpType
                m_CurGpIndex = I
                m_CurGpNumber = m_CurGpNumber + 1
                Found = True
                Exit For
            End If
        Next I
    End If
        
    If Found = False Then
        Set m_CurGroup = Nothing
        m_CurGroupSet = False
        m_CurGpType = Church
        m_CurGpIndex = -1
        m_CurGpNumber = 0
    End If
    
    FindNextGroupByType = Not Found

End Function

Public Function FindGroupByTypeSubTypeAndName(ByVal gpType As GroupTypes, ByVal GpSType As String, ByVal gpName As String) As Boolean

    Dim I As Integer
    Dim Found, Failed As Boolean
    
    Found = False
    
    If m_CurGroupSet = False Then
        If FindFirstGroupByType(gpType) = True Then
            Debug.Print "Unable to locate any groups of type " + PCTypeString(gpType + 1) + " in GroupByTypeSubTypeAndName"
            FindGroupByTypeSubTypeAndName = True    'return an error
            Exit Function
        End If
    End If
    
    If ((m_CurGroup.GroupName = gpName) And (m_CurGroup.gpType = gpType) And (m_CurGroup.GpSubType.SubTypeString = GpSType)) Then
        'Debug.Print "Already at the proper current group in find by type, subtype, & name."
        Found = True                                'already there, so get ready to exit
    Else
        If (Not (m_CurGroup.GroupName = gpName)) Then      'switch to proper gpType if necessary
            If FindFirstGroupByType(gpType) = True Then
                Debug.Print "Unable to locate any groups of type " + PCTypeString(gpType + 1) + " in GroupByTypeSubTypeAndName"
                FindGroupByTypeSubTypeAndName = True    'return an error
                Exit Function
            End If
        End If
        Found = True
        Do While ((m_CurGroup.GroupName <> gpName) Or (m_CurGroup.GpSubType.SubTypeString <> GpSType))
            I = I + 1
            If FindNextGroupByType = True Then
                Debug.Print "Failed to find group by type, subtype, and name.  Name:" + gpName
                Found = False
                Exit Do
            End If
        Loop
        If Found = False Then
            Debug.Print "Didn't find the group after " + CStr(I) + " searchs."
        Else
            'Debug.Print "Found group:" + gpName + " after " + CStr(I) + " searches."
        End If
    End If

    FindGroupByTypeSubTypeAndName = Not Found

End Function

Public Property Get CurGroupType() As GroupTypes

    CurGroupType = m_CurGpType

End Property

Public Property Get CurGroupIndex() As Integer

    CurGroupIndex = m_CurGpIndex

End Property

Public Property Let CurGroupIndex(vData As Integer)

    Dim I, J As Integer

    If vData < 1 Then
        Debug.Print "Tried to set Current Group Index to " + CStr(vData)
    ElseIf vData > newtown.Groups.count Then
        Debug.Print "Tried to set Current Group Index past the limit"
    Else
        Set m_CurGroup = m_Groups.Item(vData)
        m_CurGroupSet = True
        m_CurGpType = m_CurGroup.gpType
        m_CurGpIndex = vData
        J = 0
        For I = 1 To vData - 1
            If newtown.Groups(I).gpType = m_CurGpType Then J = J + 1
        Next I
        m_CurGpNumber = J + 1
    End If

End Property

Public Property Get CurGroupSet() As Boolean

    CurGroupSet = m_CurGroupSet

End Property

Public Property Set Stats(vData As clsStatistics)

    Set m_Stats = vData

End Property

Public Property Get Stats() As clsStatistics

    Set Stats = m_Stats

End Property

Public Property Set Groups(vData As Collection)

    Set m_Groups = vData

End Property

Public Property Get Groups() As Collection

    Set Groups = m_Groups

End Property

Public Sub AddGroup(vData As clsGroup, Optional BeforeIndex As Integer = -1)

    If BeforeIndex = -1 Then        'just stick it on the end
        If m_Groups.count = 0 Then
            Call m_Groups.Add(vData)
        Else
            Call m_Groups.Add(vData, , , m_Groups.count)
        End If
    Else                            'put in in a particular place
        Call m_Groups.Add(vData, , BeforeIndex)
    End If

End Sub

Public Sub RemGroup(Index As Long)

    If IsObject(m_Groups.Item(Index)) Then
        m_Groups.Remove (Index)
    Else
        Debug.Print "ERROR: Attempt to remove non-existent group."
    End If
    
    If Index = m_CurGpIndex And Index > 0 Then m_CurGpIndex = m_CurGpIndex - 1

End Sub

'Public Property Set CurGroup(vData As clsGroup)
'
'    If vData < 1 Then
'        Debug.Print "Tried to set CurGroup to " + CStr(vData)
'        m_Groups.Add vData
'        m_CurGpIndex = 1
'    ElseIf m_CurGpIndex > m_Groups.count Then
'        m_Groups.Add vData
'        m_CurGpIndex = 1
'    Else
'        m_Groups.Remove (m_CurGpIndex)
'        If m_CurGpIndex >= m_Groups.count Then
'            m_Groups.Add vData, , , m_CurGpIndex - 1
'        Else
'            m_Groups.Add vData, , m_CurGpIndex
'        End If
'    End If
'
'End Property

Public Property Get CurGroup() As clsGroup

    If m_CurGpIndex < 1 Then
        Set CurGroup = Nothing
    ElseIf m_CurGpIndex > m_Groups.count Then
        Set CurGroup = Nothing
    Else
        Set CurGroup = m_CurGroup
        'Set CurGroup = m_Groups.Item(m_CurGpIndex)
    End If

End Property

Public Sub CalculateGPLimit(LimitMod As Integer)
    
    Dim Limit As Long
    Dim LimitLow As Long
    Dim LimitHigh As Long

    If m_SizeClass = 0 Then
        LimitLow = 0
    Else
        LimitLow = m_LimitBase(m_SizeClass - 1) / 4
    End If
    
    LimitHigh = m_LimitBase(m_SizeClass + 1) * 2
    
    If LimitMod < 50 Then
        Limit = LimitLow + ((m_LimitBase(m_SizeClass) - LimitLow) * LimitMod / 50)
    ElseIf LimitMod = 50 Then
        Limit = m_LimitBase(m_SizeClass)
    Else
        Limit = m_LimitBase(m_SizeClass) + ((LimitHigh - m_LimitBase(m_SizeClass)) * (LimitMod - 50) / 50)
    End If
        
    m_GPLimitMod = LimitMod
    m_GPLimit = Limit

End Sub

Public Sub RandomizePopulation()

    m_Population = m_SizeBase(m_SizeClass) + ((m_SizeMod / 100) * (m_SizeBase(m_SizeClass + 1) - m_SizeBase(m_SizeClass)))

End Sub

Public Property Let SizeClass(ByVal vData As Integer)
    
    m_SizeClass = vData

End Property

Public Property Get SizeClass() As Integer
    
    SizeClass = m_SizeClass

End Property

Public Property Let GPLimitMod(ByVal vData As Long)
    
    m_GPLimitMod = vData

End Property

Public Property Get GPLimitMod() As Long
    
    GPLimitMod = m_GPLimitMod

End Property

Public Property Let GPLimit(ByVal vData As Long)
    
    m_GPLimit = vData

End Property

Public Property Get GPLimit() As Long
    
    GPLimit = m_GPLimit

End Property

Public Property Let Population(ByVal vData As Long)
    
    m_Population = vData

End Property

Public Property Get Population() As Long
    
    Population = m_Population

End Property

Public Property Let SizeMod(ByVal vData As Integer)
    
    m_SizeMod = vData

End Property

Public Property Get SizeMod() As Integer
    
    SizeMod = m_SizeMod

End Property

Public Property Set RaceDist(ByVal vData As clsRaceDistribution)
    
    Set m_RaceDist = vData

End Property

Public Property Get RaceDist() As clsRaceDistribution
    
    Set RaceDist = m_RaceDist

End Property

Public Property Set AlignDist(ByVal vData As clsAlignDist)
    
    Set m_AlignDist = vData

End Property

Public Property Get AlignDist() As clsAlignDist
    
    Set AlignDist = m_AlignDist

End Property

Public Property Set Areas(ByVal vData As clsSurroundings)
    
    Set m_Area = vData

End Property

Public Property Get Areas() As clsSurroundings
    
    Set Areas = m_Area

End Property

Public Property Set PowerCenters(ByVal vData As clsPowerCenters)

    Set m_PwrCtrs = vData

End Property

Public Property Get PowerCenters() As clsPowerCenters

    Set PowerCenters = m_PwrCtrs

End Property

Public Property Set Pantheon(ByVal vData As clsPantheon)

    Set m_Pantheon = vData

End Property

Public Property Get Pantheon() As clsPantheon

    Set Pantheon = m_Pantheon

End Property

Public Property Let TownName(ByVal vData As String)
    
    m_TownName = vData

End Property

Public Property Get TownName() As String
    
    TownName = m_TownName

End Property

Private Sub Class_Initialize()

    m_TownName = ""
    Set m_Area = New clsSurroundings
    Set m_AlignDist = New clsAlignDist
    Set m_RaceDist = New clsRaceDistribution
    Set m_PwrCtrs = New clsPowerCenters
    Set m_Pantheon = New clsPantheon
    Set m_Groups = New Collection
    Set m_Stats = New clsStatistics
    m_SizeMod = 50
    m_Population = 0
    m_CurGpIndex = 0

    m_SizeBase(0) = 20
    m_SizeBase(1) = 80
    m_SizeBase(2) = 400
    m_SizeBase(3) = 900
    m_SizeBase(4) = 2000
    m_SizeBase(5) = 5000
    m_SizeBase(6) = 12000
    m_SizeBase(7) = 25000
    m_SizeBase(8) = 200000
        
    m_LimitBase(0) = 40
    m_LimitBase(1) = 100
    m_LimitBase(2) = 200
    m_LimitBase(3) = 800
    m_LimitBase(4) = 3000
    m_LimitBase(5) = 15000
    m_LimitBase(6) = 40000
    m_LimitBase(7) = 100000
    m_LimitBase(8) = 400000

End Sub

Public Function SetCurGroupToIndex(ByVal Index As Integer, ByVal gType As GroupTypes) As Boolean

    Dim I, J As Integer
    
    If m_CurGpNumber = Index And m_CurGpType = gType Then       'already there
        SetCurGroupToIndex = False              'return NO error
        'Debug.Print "Already there"
        Exit Function
    End If
    
    If FindFirstGroupByType(gType) = True Then
        Debug.Print "There are no " + PCTypeString(gType + 1) + " groups and you are trying to find one in SetCurGroupToIndex"
        SetCurGroupToIndex = True               'return an error
        Exit Function
    End If

    I = 1
    Do While (Index > I)
        If FindNextGroupByType = True Then
            Debug.Print "Indexed to non-existent " + PCTypeString(gType + 1) + " group in SetCurGroupToIndex, index=" + CStr(I)
            SetCurGroupToIndex = True           'return an error
            Exit Function
        End If
        I = I + 1
    Loop
    
    'Debug.Print "Indexed " + PCTypeString(gType + 1) + " to index # " + CStr(I) + " when desired index was " + CStr(Index)
    SetCurGroupToIndex = False                  'return NO error

End Function

Public Sub RemoveAll(grType As GroupTypes)

    Dim I As Integer
    
    For I = m_Groups.count To 1 Step -1
        If m_Groups.Item(I).gpType = grType And m_Groups.Item(I).PowerCenter = False Then
            Call m_Groups.Remove(I)
        End If
    Next
    
    Select Case grType
    Case Church
        m_Stats.NofC = 0
    Case Wizard
        m_Stats.NofW = 0
    Case Mercenary
        m_Stats.NofPMG = 0
    Case UndeadGroup
        m_Stats.NofU = 0
    Case Gang
        m_Stats.NofG = 0
    End Select

End Sub

